"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PluginType = void 0;

/*
 * Copyright Elasticsearch B.V. and/or licensed to Elasticsearch B.V. under one
 * or more contributor license agreements. Licensed under the Elastic License
 * 2.0 and the Server Side Public License, v 1; you may not use this file except
 * in compliance with, at your election, the Elastic License 2.0 or the Server
 * Side Public License, v 1.
 */

/**
 * Dedicated type for plugin name/id that is supposed to make Map/Set/Arrays
 * that use it as a key or value more obvious.
 *
 * @public
 */

/** @public */

/** @public */
let PluginType;
/**
 * Small container object used to expose information about discovered plugins that may
 * or may not have been started.
 * @public
 */

exports.PluginType = PluginType;

(function (PluginType) {
  PluginType["preboot"] = "preboot";
  PluginType["standard"] = "standard";
})(PluginType || (exports.PluginType = PluginType = {}));