"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LimitedSizeArray = void 0;

var t = _interopRequireWildcard(require("io-ts"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/*
 * Copyright Elasticsearch B.V. and/or licensed to Elasticsearch B.V. under one
 * or more contributor license agreements. Licensed under the Elastic License
 * 2.0 and the Server Side Public License, v 1; you may not use this file except
 * in compliance with, at your election, the Elastic License 2.0 or the Server
 * Side Public License, v 1.
 */
const LimitedSizeArray = ({
  codec,
  minSize,
  maxSize,
  name = `LimitedSizeArray<${codec.name}>`
}) => {
  const arrType = t.array(codec);
  return new t.Type(name, arrType.is, (input, context) => {
    if (Array.isArray(input) && (minSize && input.length < minSize || maxSize && input.length > maxSize)) {
      return t.failure(input, context, `Array size (${input.length}) is out of bounds: min: ${minSize !== null && minSize !== void 0 ? minSize : 'not specified'}, max: ${maxSize !== null && maxSize !== void 0 ? maxSize : 'not specified'}`);
    } else {
      return arrType.validate(input, context);
    }
  }, t.identity);
};

exports.LimitedSizeArray = LimitedSizeArray;