/*
 * Copyright Elasticsearch B.V. and/or licensed to Elasticsearch B.V. under one
 * or more contributor license agreements. Licensed under the Elastic License
 * 2.0 and the Server Side Public License, v 1; you may not use this file except
 * in compliance with, at your election, the Elastic License 2.0 or the Server
 * Side Public License, v 1.
 */
export function parseEndpoint(endpoint) {
  var parts = endpoint.split(' ');
  var method = parts[0].trim().toLowerCase();
  var pathname = parts[1].trim();

  if (!['get', 'post', 'put', 'delete'].includes(method)) {
    throw new Error('Endpoint was not prefixed with a valid HTTP method');
  }

  return {
    method: method,
    pathname: pathname
  };
}