"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.formatColumn = void 0;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/*
 * Copyright Elasticsearch B.V. and/or licensed to Elasticsearch B.V. under one
 * or more contributor license agreements. Licensed under the Elastic License
 * 2.0; you may not use this file except in compliance with the Elastic License
 * 2.0.
 */
const formatColumn = {
  name: 'lens_format_column',
  type: 'datatable',
  help: '',
  args: {
    format: {
      types: ['string'],
      help: '',
      required: true
    },
    columnId: {
      types: ['string'],
      help: '',
      required: true
    },
    decimals: {
      types: ['number'],
      help: ''
    },
    suffix: {
      types: ['string'],
      help: ''
    },
    parentFormat: {
      types: ['string'],
      help: ''
    }
  },
  inputTypes: ['datatable'],

  async fn(...args) {
    /** Build optimization: prevent adding extra code into initial bundle **/
    const {
      formatColumnFn
    } = await Promise.resolve().then(() => _interopRequireWildcard(require('./format_column_fn')));
    return formatColumnFn(...args);
  }

};
exports.formatColumn = formatColumn;