"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.emsWorldLayerId = exports.ZOOM_PRECISION = exports.WIZARD_ID = exports.VECTOR_STYLES = exports.VECTOR_SHAPE_TYPE = exports.TOP_TERM_PERCENTAGE_SUFFIX = exports.SYMBOLIZE_AS_TYPES = exports.STYLE_TYPE = exports.SPATIAL_FILTERS_LAYER_ID = exports.SOURCE_TYPES = exports.SOURCE_META_DATA_REQUEST_ID = exports.SOURCE_FORMATTERS_DATA_REQUEST_ID = exports.SOURCE_DATA_REQUEST_ID = exports.SOURCE_BOUNDS_DATA_REQUEST_ID = exports.SCALING_TYPES = exports.RENDER_AS = exports.POLYGON_COORDINATES_EXTERIOR_INDEX = exports.ORDINAL_DATA_TYPES = exports.OPEN_LAYER_WIZARD = exports.NO_EMS_LOCALE = exports.MVT_GETTILE_API_PATH = exports.MVT_GETGRIDTILE_API_PATH = exports.MVT_FIELD_TYPE = exports.MIN_ZOOM = exports.META_DATA_REQUEST_ID_SUFFIX = exports.MB_SOURCE_ID_LAYER_ID_PREFIX_DELIMITER = exports.MB_LOOKUP_FUNCTION = exports.MAX_ZOOM = exports.MAX_DRAWING_SIZE_BYTES = exports.MAP_SAVED_OBJECT_TYPE = exports.MAP_PATH = exports.MAPS_NEW_VECTOR_LAYER_META_CREATED_BY = exports.MAPS_APP_PATH = exports.MAKI_ICON_SIZE = exports.LON_INDEX = exports.LAYER_WIZARD_CATEGORY = exports.LAYER_TYPE = exports.LAYER_STYLE_TYPE = exports.LAT_INDEX = exports.LABEL_BORDER_SIZES = exports.KBN_IS_CENTROID_FEATURE = exports.JOIN_FIELD_NAME_PREFIX = exports.INITIAL_LOCATION = exports.INITIAL_LAYERS_KEY = exports.INDEX_SOURCE_API_PATH = exports.INDEX_SETTINGS_API_PATH = exports.INDEX_FEATURE_PATH = exports.ICON_SOURCE = exports.HALF_MAKI_ICON_SIZE = exports.GRID_RESOLUTION = exports.GIS_API_PATH = exports.GET_MATCHING_INDEXES_PATH = exports.GEO_JSON_TYPE = exports.GEOTILE_GRID_AGG_NAME = exports.GEOCENTROID_AGG_NAME = exports.FORMATTERS_DATA_REQUEST_ID_SUFFIX = exports.FONTS_API_PATH = exports.FIELD_ORIGIN = exports.FEATURE_VISIBLE_PROPERTY_NAME = exports.ES_SPATIAL_RELATIONS = exports.ES_GEO_FIELD_TYPES = exports.ES_GEO_FIELD_TYPE = exports.EMPTY_FEATURE_COLLECTION = exports.DRAW_SHAPE = exports.DRAW_MODE = exports.DEFAULT_PERCENTILES = exports.DEFAULT_PERCENTILE = exports.DEFAULT_MAX_RESULT_WINDOW = exports.DEFAULT_MAX_INNER_RESULT_WINDOW = exports.DEFAULT_MAX_BUCKETS_LIMIT = exports.DEFAULT_ICON = exports.DEFAULT_CUSTOM_ICON_RADIUS = exports.DEFAULT_CUSTOM_ICON_CUTOFF = exports.DECIMAL_DEGREES_PRECISION = exports.DATA_MAPPING_FUNCTION = exports.CUSTOM_ICON_SIZE = exports.CUSTOM_ICON_PREFIX_SDF = exports.COUNT_PROP_NAME = exports.COUNT_PROP_LABEL = exports.COLOR_MAP_TYPE = exports.CHECK_IS_DRAWING_INDEX = exports.CATEGORICAL_DATA_TYPES = exports.AUTOSELECT_EMS_LOCALE = exports.APP_NAME = exports.APP_ID = exports.APP_ICON_SOLUTION = exports.APP_ICON = exports.API_ROOT_PATH = exports.AGG_TYPE = exports.AGG_DELIMITER = void 0;
exports.getEditPath = getEditPath;
exports.getFullPath = getFullPath;
exports.getNewMapPath = getNewMapPath;

var _i18n = require("@kbn/i18n");

/*
 * Copyright Elasticsearch B.V. and/or licensed to Elasticsearch B.V. under one
 * or more contributor license agreements. Licensed under the Elastic License
 * 2.0; you may not use this file except in compliance with the Elastic License
 * 2.0.
 */
const MAP_SAVED_OBJECT_TYPE = 'map';
exports.MAP_SAVED_OBJECT_TYPE = MAP_SAVED_OBJECT_TYPE;
const APP_ID = 'maps';
exports.APP_ID = APP_ID;
const APP_ICON = 'gisApp';
exports.APP_ICON = APP_ICON;
const APP_ICON_SOLUTION = 'logoKibana';
exports.APP_ICON_SOLUTION = APP_ICON_SOLUTION;

const APP_NAME = _i18n.i18n.translate('xpack.maps.visTypeAlias.title', {
  defaultMessage: 'Maps'
});

exports.APP_NAME = APP_NAME;
const INITIAL_LAYERS_KEY = 'initialLayers';
exports.INITIAL_LAYERS_KEY = INITIAL_LAYERS_KEY;
const MAPS_APP_PATH = `app/${APP_ID}`;
exports.MAPS_APP_PATH = MAPS_APP_PATH;
const MAP_PATH = 'map';
exports.MAP_PATH = MAP_PATH;
const GIS_API_PATH = `api/${APP_ID}`;
exports.GIS_API_PATH = GIS_API_PATH;
const INDEX_SETTINGS_API_PATH = `${GIS_API_PATH}/indexSettings`;
exports.INDEX_SETTINGS_API_PATH = INDEX_SETTINGS_API_PATH;
const FONTS_API_PATH = `${GIS_API_PATH}/fonts`;
exports.FONTS_API_PATH = FONTS_API_PATH;
const INDEX_SOURCE_API_PATH = `${GIS_API_PATH}/docSource`;
exports.INDEX_SOURCE_API_PATH = INDEX_SOURCE_API_PATH;
const API_ROOT_PATH = `/${GIS_API_PATH}`;
exports.API_ROOT_PATH = API_ROOT_PATH;
const INDEX_FEATURE_PATH = `/${GIS_API_PATH}/feature`;
exports.INDEX_FEATURE_PATH = INDEX_FEATURE_PATH;
const GET_MATCHING_INDEXES_PATH = `/${GIS_API_PATH}/getMatchingIndexes`;
exports.GET_MATCHING_INDEXES_PATH = GET_MATCHING_INDEXES_PATH;
const CHECK_IS_DRAWING_INDEX = `/${GIS_API_PATH}/checkIsDrawingIndex`;
exports.CHECK_IS_DRAWING_INDEX = CHECK_IS_DRAWING_INDEX;
const MVT_GETTILE_API_PATH = 'mvt/getTile';
exports.MVT_GETTILE_API_PATH = MVT_GETTILE_API_PATH;
const MVT_GETGRIDTILE_API_PATH = 'mvt/getGridTile';
exports.MVT_GETGRIDTILE_API_PATH = MVT_GETGRIDTILE_API_PATH;
const OPEN_LAYER_WIZARD = 'openLayerWizard'; // Identifies centroid feature.
// Centroids are a single point for representing lines, multiLines, polygons, and multiPolygons

exports.OPEN_LAYER_WIZARD = OPEN_LAYER_WIZARD;
const KBN_IS_CENTROID_FEATURE = '__kbn_is_centroid_feature__';
exports.KBN_IS_CENTROID_FEATURE = KBN_IS_CENTROID_FEATURE;

function getNewMapPath() {
  return `/${MAPS_APP_PATH}/${MAP_PATH}`;
}

function getFullPath(id) {
  return `/${MAPS_APP_PATH}${getEditPath(id)}`;
}

function getEditPath(id) {
  return id ? `/${MAP_PATH}/${id}` : `/${MAP_PATH}`;
}

let LAYER_TYPE;
exports.LAYER_TYPE = LAYER_TYPE;

(function (LAYER_TYPE) {
  LAYER_TYPE["RASTER_TILE"] = "RASTER_TILE";
  LAYER_TYPE["GEOJSON_VECTOR"] = "GEOJSON_VECTOR";
  LAYER_TYPE["EMS_VECTOR_TILE"] = "EMS_VECTOR_TILE";
  LAYER_TYPE["HEATMAP"] = "HEATMAP";
  LAYER_TYPE["BLENDED_VECTOR"] = "BLENDED_VECTOR";
  LAYER_TYPE["MVT_VECTOR"] = "MVT_VECTOR";
})(LAYER_TYPE || (exports.LAYER_TYPE = LAYER_TYPE = {}));

let SOURCE_TYPES;
exports.SOURCE_TYPES = SOURCE_TYPES;

(function (SOURCE_TYPES) {
  SOURCE_TYPES["EMS_TMS"] = "EMS_TMS";
  SOURCE_TYPES["EMS_FILE"] = "EMS_FILE";
  SOURCE_TYPES["ES_GEO_GRID"] = "ES_GEO_GRID";
  SOURCE_TYPES["ES_GEO_LINE"] = "ES_GEO_LINE";
  SOURCE_TYPES["ES_SEARCH"] = "ES_SEARCH";
  SOURCE_TYPES["ES_PEW_PEW"] = "ES_PEW_PEW";
  SOURCE_TYPES["ES_TERM_SOURCE"] = "ES_TERM_SOURCE";
  SOURCE_TYPES["ES_ML_ANOMALIES"] = "ML_ANOMALIES";
  SOURCE_TYPES["EMS_XYZ"] = "EMS_XYZ";
  SOURCE_TYPES["WMS"] = "WMS";
  SOURCE_TYPES["KIBANA_TILEMAP"] = "KIBANA_TILEMAP";
  SOURCE_TYPES["GEOJSON_FILE"] = "GEOJSON_FILE";
  SOURCE_TYPES["MVT_SINGLE_LAYER"] = "MVT_SINGLE_LAYER";
  SOURCE_TYPES["TABLE_SOURCE"] = "TABLE_SOURCE";
})(SOURCE_TYPES || (exports.SOURCE_TYPES = SOURCE_TYPES = {}));

let FIELD_ORIGIN;
exports.FIELD_ORIGIN = FIELD_ORIGIN;

(function (FIELD_ORIGIN) {
  FIELD_ORIGIN["SOURCE"] = "source";
  FIELD_ORIGIN["JOIN"] = "join";
})(FIELD_ORIGIN || (exports.FIELD_ORIGIN = FIELD_ORIGIN = {}));

const JOIN_FIELD_NAME_PREFIX = '__kbnjoin__';
exports.JOIN_FIELD_NAME_PREFIX = JOIN_FIELD_NAME_PREFIX;
const META_DATA_REQUEST_ID_SUFFIX = 'meta';
exports.META_DATA_REQUEST_ID_SUFFIX = META_DATA_REQUEST_ID_SUFFIX;
const FORMATTERS_DATA_REQUEST_ID_SUFFIX = 'formatters';
exports.FORMATTERS_DATA_REQUEST_ID_SUFFIX = FORMATTERS_DATA_REQUEST_ID_SUFFIX;
const SOURCE_DATA_REQUEST_ID = 'source';
exports.SOURCE_DATA_REQUEST_ID = SOURCE_DATA_REQUEST_ID;
const SOURCE_META_DATA_REQUEST_ID = `${SOURCE_DATA_REQUEST_ID}_${META_DATA_REQUEST_ID_SUFFIX}`;
exports.SOURCE_META_DATA_REQUEST_ID = SOURCE_META_DATA_REQUEST_ID;
const SOURCE_FORMATTERS_DATA_REQUEST_ID = `${SOURCE_DATA_REQUEST_ID}_${FORMATTERS_DATA_REQUEST_ID_SUFFIX}`;
exports.SOURCE_FORMATTERS_DATA_REQUEST_ID = SOURCE_FORMATTERS_DATA_REQUEST_ID;
const SOURCE_BOUNDS_DATA_REQUEST_ID = `${SOURCE_DATA_REQUEST_ID}_bounds`;
exports.SOURCE_BOUNDS_DATA_REQUEST_ID = SOURCE_BOUNDS_DATA_REQUEST_ID;
const MIN_ZOOM = 0;
exports.MIN_ZOOM = MIN_ZOOM;
const MAX_ZOOM = 24;
exports.MAX_ZOOM = MAX_ZOOM;
const DECIMAL_DEGREES_PRECISION = 5; // meters precision

exports.DECIMAL_DEGREES_PRECISION = DECIMAL_DEGREES_PRECISION;
const ZOOM_PRECISION = 2;
exports.ZOOM_PRECISION = ZOOM_PRECISION;
const DEFAULT_MAX_RESULT_WINDOW = 10000;
exports.DEFAULT_MAX_RESULT_WINDOW = DEFAULT_MAX_RESULT_WINDOW;
const DEFAULT_MAX_INNER_RESULT_WINDOW = 100;
exports.DEFAULT_MAX_INNER_RESULT_WINDOW = DEFAULT_MAX_INNER_RESULT_WINDOW;
const DEFAULT_MAX_BUCKETS_LIMIT = 65535;
exports.DEFAULT_MAX_BUCKETS_LIMIT = DEFAULT_MAX_BUCKETS_LIMIT;
const FEATURE_VISIBLE_PROPERTY_NAME = '__kbn_isvisibleduetojoin__';
exports.FEATURE_VISIBLE_PROPERTY_NAME = FEATURE_VISIBLE_PROPERTY_NAME;
const MB_SOURCE_ID_LAYER_ID_PREFIX_DELIMITER = '_';
exports.MB_SOURCE_ID_LAYER_ID_PREFIX_DELIMITER = MB_SOURCE_ID_LAYER_ID_PREFIX_DELIMITER;
let ES_GEO_FIELD_TYPE; // Using strings instead of ES_GEO_FIELD_TYPE enum to avoid typeing errors where IndexPatternField.type is compared to value

exports.ES_GEO_FIELD_TYPE = ES_GEO_FIELD_TYPE;

(function (ES_GEO_FIELD_TYPE) {
  ES_GEO_FIELD_TYPE["GEO_POINT"] = "geo_point";
  ES_GEO_FIELD_TYPE["GEO_SHAPE"] = "geo_shape";
})(ES_GEO_FIELD_TYPE || (exports.ES_GEO_FIELD_TYPE = ES_GEO_FIELD_TYPE = {}));

const ES_GEO_FIELD_TYPES = ['geo_point', 'geo_shape'];
exports.ES_GEO_FIELD_TYPES = ES_GEO_FIELD_TYPES;
let ES_SPATIAL_RELATIONS;
exports.ES_SPATIAL_RELATIONS = ES_SPATIAL_RELATIONS;

(function (ES_SPATIAL_RELATIONS) {
  ES_SPATIAL_RELATIONS["INTERSECTS"] = "INTERSECTS";
  ES_SPATIAL_RELATIONS["DISJOINT"] = "DISJOINT";
  ES_SPATIAL_RELATIONS["WITHIN"] = "WITHIN";
})(ES_SPATIAL_RELATIONS || (exports.ES_SPATIAL_RELATIONS = ES_SPATIAL_RELATIONS = {}));

let GEO_JSON_TYPE;
exports.GEO_JSON_TYPE = GEO_JSON_TYPE;

(function (GEO_JSON_TYPE) {
  GEO_JSON_TYPE["POINT"] = "Point";
  GEO_JSON_TYPE["MULTI_POINT"] = "MultiPoint";
  GEO_JSON_TYPE["LINE_STRING"] = "LineString";
  GEO_JSON_TYPE["MULTI_LINE_STRING"] = "MultiLineString";
  GEO_JSON_TYPE["POLYGON"] = "Polygon";
  GEO_JSON_TYPE["MULTI_POLYGON"] = "MultiPolygon";
  GEO_JSON_TYPE["GEOMETRY_COLLECTION"] = "GeometryCollection";
})(GEO_JSON_TYPE || (exports.GEO_JSON_TYPE = GEO_JSON_TYPE = {}));

const POLYGON_COORDINATES_EXTERIOR_INDEX = 0;
exports.POLYGON_COORDINATES_EXTERIOR_INDEX = POLYGON_COORDINATES_EXTERIOR_INDEX;
const LON_INDEX = 0;
exports.LON_INDEX = LON_INDEX;
const LAT_INDEX = 1;
exports.LAT_INDEX = LAT_INDEX;
const EMPTY_FEATURE_COLLECTION = {
  type: 'FeatureCollection',
  features: []
};
exports.EMPTY_FEATURE_COLLECTION = EMPTY_FEATURE_COLLECTION;
let DRAW_MODE;
exports.DRAW_MODE = DRAW_MODE;

(function (DRAW_MODE) {
  DRAW_MODE["DRAW_SHAPES"] = "DRAW_SHAPES";
  DRAW_MODE["DRAW_POINTS"] = "DRAW_POINTS";
  DRAW_MODE["DRAW_FILTERS"] = "DRAW_FILTERS";
  DRAW_MODE["NONE"] = "NONE";
})(DRAW_MODE || (exports.DRAW_MODE = DRAW_MODE = {}));

let DRAW_SHAPE;
exports.DRAW_SHAPE = DRAW_SHAPE;

(function (DRAW_SHAPE) {
  DRAW_SHAPE["BOUNDS"] = "BOUNDS";
  DRAW_SHAPE["DISTANCE"] = "DISTANCE";
  DRAW_SHAPE["POLYGON"] = "POLYGON";
  DRAW_SHAPE["POINT"] = "POINT";
  DRAW_SHAPE["LINE"] = "LINE";
  DRAW_SHAPE["SIMPLE_SELECT"] = "SIMPLE_SELECT";
  DRAW_SHAPE["DELETE"] = "DELETE";
  DRAW_SHAPE["WAIT"] = "WAIT";
})(DRAW_SHAPE || (exports.DRAW_SHAPE = DRAW_SHAPE = {}));

const AGG_DELIMITER = '_of_';
exports.AGG_DELIMITER = AGG_DELIMITER;
let AGG_TYPE;
exports.AGG_TYPE = AGG_TYPE;

(function (AGG_TYPE) {
  AGG_TYPE["AVG"] = "avg";
  AGG_TYPE["COUNT"] = "count";
  AGG_TYPE["MAX"] = "max";
  AGG_TYPE["MIN"] = "min";
  AGG_TYPE["SUM"] = "sum";
  AGG_TYPE["TERMS"] = "terms";
  AGG_TYPE["PERCENTILE"] = "percentile";
  AGG_TYPE["UNIQUE_COUNT"] = "cardinality";
})(AGG_TYPE || (exports.AGG_TYPE = AGG_TYPE = {}));

let RENDER_AS;
exports.RENDER_AS = RENDER_AS;

(function (RENDER_AS) {
  RENDER_AS["HEATMAP"] = "heatmap";
  RENDER_AS["POINT"] = "point";
  RENDER_AS["GRID"] = "grid";
  RENDER_AS["HEX"] = "hex";
})(RENDER_AS || (exports.RENDER_AS = RENDER_AS = {}));

let GRID_RESOLUTION;
exports.GRID_RESOLUTION = GRID_RESOLUTION;

(function (GRID_RESOLUTION) {
  GRID_RESOLUTION["COARSE"] = "COARSE";
  GRID_RESOLUTION["FINE"] = "FINE";
  GRID_RESOLUTION["MOST_FINE"] = "MOST_FINE";
  GRID_RESOLUTION["SUPER_FINE"] = "SUPER_FINE";
})(GRID_RESOLUTION || (exports.GRID_RESOLUTION = GRID_RESOLUTION = {}));

const GEOTILE_GRID_AGG_NAME = 'gridSplit';
exports.GEOTILE_GRID_AGG_NAME = GEOTILE_GRID_AGG_NAME;
const GEOCENTROID_AGG_NAME = 'gridCentroid';
exports.GEOCENTROID_AGG_NAME = GEOCENTROID_AGG_NAME;
const TOP_TERM_PERCENTAGE_SUFFIX = '__percentage';
exports.TOP_TERM_PERCENTAGE_SUFFIX = TOP_TERM_PERCENTAGE_SUFFIX;
const DEFAULT_PERCENTILE = 50;
exports.DEFAULT_PERCENTILE = DEFAULT_PERCENTILE;

const COUNT_PROP_LABEL = _i18n.i18n.translate('xpack.maps.aggs.defaultCountLabel', {
  defaultMessage: 'count'
});

exports.COUNT_PROP_LABEL = COUNT_PROP_LABEL;
const COUNT_PROP_NAME = 'doc_count';
exports.COUNT_PROP_NAME = COUNT_PROP_NAME;
let STYLE_TYPE;
exports.STYLE_TYPE = STYLE_TYPE;

(function (STYLE_TYPE) {
  STYLE_TYPE["STATIC"] = "STATIC";
  STYLE_TYPE["DYNAMIC"] = "DYNAMIC";
})(STYLE_TYPE || (exports.STYLE_TYPE = STYLE_TYPE = {}));

let LAYER_STYLE_TYPE;
exports.LAYER_STYLE_TYPE = LAYER_STYLE_TYPE;

(function (LAYER_STYLE_TYPE) {
  LAYER_STYLE_TYPE["VECTOR"] = "VECTOR";
  LAYER_STYLE_TYPE["HEATMAP"] = "HEATMAP";
  LAYER_STYLE_TYPE["TILE"] = "TILE";
  LAYER_STYLE_TYPE["EMS_VECTOR_TILE"] = "EMS_VECTOR_TILE";
})(LAYER_STYLE_TYPE || (exports.LAYER_STYLE_TYPE = LAYER_STYLE_TYPE = {}));

let COLOR_MAP_TYPE;
exports.COLOR_MAP_TYPE = COLOR_MAP_TYPE;

(function (COLOR_MAP_TYPE) {
  COLOR_MAP_TYPE["CATEGORICAL"] = "CATEGORICAL";
  COLOR_MAP_TYPE["ORDINAL"] = "ORDINAL";
})(COLOR_MAP_TYPE || (exports.COLOR_MAP_TYPE = COLOR_MAP_TYPE = {}));

const CATEGORICAL_DATA_TYPES = ['string', 'ip', 'boolean'];
exports.CATEGORICAL_DATA_TYPES = CATEGORICAL_DATA_TYPES;
const ORDINAL_DATA_TYPES = ['number', 'date'];
exports.ORDINAL_DATA_TYPES = ORDINAL_DATA_TYPES;
let SYMBOLIZE_AS_TYPES;
exports.SYMBOLIZE_AS_TYPES = SYMBOLIZE_AS_TYPES;

(function (SYMBOLIZE_AS_TYPES) {
  SYMBOLIZE_AS_TYPES["CIRCLE"] = "circle";
  SYMBOLIZE_AS_TYPES["ICON"] = "icon";
})(SYMBOLIZE_AS_TYPES || (exports.SYMBOLIZE_AS_TYPES = SYMBOLIZE_AS_TYPES = {}));

let LABEL_BORDER_SIZES;
exports.LABEL_BORDER_SIZES = LABEL_BORDER_SIZES;

(function (LABEL_BORDER_SIZES) {
  LABEL_BORDER_SIZES["NONE"] = "NONE";
  LABEL_BORDER_SIZES["SMALL"] = "SMALL";
  LABEL_BORDER_SIZES["MEDIUM"] = "MEDIUM";
  LABEL_BORDER_SIZES["LARGE"] = "LARGE";
})(LABEL_BORDER_SIZES || (exports.LABEL_BORDER_SIZES = LABEL_BORDER_SIZES = {}));

const DEFAULT_ICON = 'marker';
exports.DEFAULT_ICON = DEFAULT_ICON;
const DEFAULT_CUSTOM_ICON_CUTOFF = 0.25;
exports.DEFAULT_CUSTOM_ICON_CUTOFF = DEFAULT_CUSTOM_ICON_CUTOFF;
const DEFAULT_CUSTOM_ICON_RADIUS = 0.25;
exports.DEFAULT_CUSTOM_ICON_RADIUS = DEFAULT_CUSTOM_ICON_RADIUS;
const CUSTOM_ICON_SIZE = 64;
exports.CUSTOM_ICON_SIZE = CUSTOM_ICON_SIZE;
const CUSTOM_ICON_PREFIX_SDF = '__kbn__custom_icon_sdf__';
exports.CUSTOM_ICON_PREFIX_SDF = CUSTOM_ICON_PREFIX_SDF;
const MAKI_ICON_SIZE = 16;
exports.MAKI_ICON_SIZE = MAKI_ICON_SIZE;
const HALF_MAKI_ICON_SIZE = MAKI_ICON_SIZE / 2;
exports.HALF_MAKI_ICON_SIZE = HALF_MAKI_ICON_SIZE;
let ICON_SOURCE;
exports.ICON_SOURCE = ICON_SOURCE;

(function (ICON_SOURCE) {
  ICON_SOURCE["CUSTOM"] = "CUSTOM";
  ICON_SOURCE["MAKI"] = "MAKI";
})(ICON_SOURCE || (exports.ICON_SOURCE = ICON_SOURCE = {}));

let VECTOR_STYLES;
exports.VECTOR_STYLES = VECTOR_STYLES;

(function (VECTOR_STYLES) {
  VECTOR_STYLES["SYMBOLIZE_AS"] = "symbolizeAs";
  VECTOR_STYLES["FILL_COLOR"] = "fillColor";
  VECTOR_STYLES["LINE_COLOR"] = "lineColor";
  VECTOR_STYLES["LINE_WIDTH"] = "lineWidth";
  VECTOR_STYLES["ICON"] = "icon";
  VECTOR_STYLES["ICON_SIZE"] = "iconSize";
  VECTOR_STYLES["ICON_ORIENTATION"] = "iconOrientation";
  VECTOR_STYLES["LABEL_TEXT"] = "labelText";
  VECTOR_STYLES["LABEL_ZOOM_RANGE"] = "labelZoomRange";
  VECTOR_STYLES["LABEL_COLOR"] = "labelColor";
  VECTOR_STYLES["LABEL_SIZE"] = "labelSize";
  VECTOR_STYLES["LABEL_BORDER_COLOR"] = "labelBorderColor";
  VECTOR_STYLES["LABEL_BORDER_SIZE"] = "labelBorderSize";
})(VECTOR_STYLES || (exports.VECTOR_STYLES = VECTOR_STYLES = {}));

let SCALING_TYPES;
exports.SCALING_TYPES = SCALING_TYPES;

(function (SCALING_TYPES) {
  SCALING_TYPES["LIMIT"] = "LIMIT";
  SCALING_TYPES["CLUSTERS"] = "CLUSTERS";
  SCALING_TYPES["TOP_HITS"] = "TOP_HITS";
  SCALING_TYPES["MVT"] = "MVT";
})(SCALING_TYPES || (exports.SCALING_TYPES = SCALING_TYPES = {}));

let MVT_FIELD_TYPE;
exports.MVT_FIELD_TYPE = MVT_FIELD_TYPE;

(function (MVT_FIELD_TYPE) {
  MVT_FIELD_TYPE["STRING"] = "String";
  MVT_FIELD_TYPE["NUMBER"] = "Number";
})(MVT_FIELD_TYPE || (exports.MVT_FIELD_TYPE = MVT_FIELD_TYPE = {}));

const SPATIAL_FILTERS_LAYER_ID = 'SPATIAL_FILTERS_LAYER_ID';
exports.SPATIAL_FILTERS_LAYER_ID = SPATIAL_FILTERS_LAYER_ID;
let INITIAL_LOCATION;
exports.INITIAL_LOCATION = INITIAL_LOCATION;

(function (INITIAL_LOCATION) {
  INITIAL_LOCATION["LAST_SAVED_LOCATION"] = "LAST_SAVED_LOCATION";
  INITIAL_LOCATION["FIXED_LOCATION"] = "FIXED_LOCATION";
  INITIAL_LOCATION["BROWSER_LOCATION"] = "BROWSER_LOCATION";
  INITIAL_LOCATION["AUTO_FIT_TO_BOUNDS"] = "AUTO_FIT_TO_BOUNDS";
})(INITIAL_LOCATION || (exports.INITIAL_LOCATION = INITIAL_LOCATION = {}));

let LAYER_WIZARD_CATEGORY;
exports.LAYER_WIZARD_CATEGORY = LAYER_WIZARD_CATEGORY;

(function (LAYER_WIZARD_CATEGORY) {
  LAYER_WIZARD_CATEGORY["ELASTICSEARCH"] = "ELASTICSEARCH";
  LAYER_WIZARD_CATEGORY["REFERENCE"] = "REFERENCE";
  LAYER_WIZARD_CATEGORY["SOLUTIONS"] = "SOLUTIONS";
})(LAYER_WIZARD_CATEGORY || (exports.LAYER_WIZARD_CATEGORY = LAYER_WIZARD_CATEGORY = {}));

let VECTOR_SHAPE_TYPE; // https://docs.mapbox.com/mapbox-gl-js/style-spec/expressions/#data-expressions

exports.VECTOR_SHAPE_TYPE = VECTOR_SHAPE_TYPE;

(function (VECTOR_SHAPE_TYPE) {
  VECTOR_SHAPE_TYPE["POINT"] = "POINT";
  VECTOR_SHAPE_TYPE["LINE"] = "LINE";
  VECTOR_SHAPE_TYPE["POLYGON"] = "POLYGON";
})(VECTOR_SHAPE_TYPE || (exports.VECTOR_SHAPE_TYPE = VECTOR_SHAPE_TYPE = {}));

let MB_LOOKUP_FUNCTION;
exports.MB_LOOKUP_FUNCTION = MB_LOOKUP_FUNCTION;

(function (MB_LOOKUP_FUNCTION) {
  MB_LOOKUP_FUNCTION["GET"] = "get";
  MB_LOOKUP_FUNCTION["FEATURE_STATE"] = "feature-state";
})(MB_LOOKUP_FUNCTION || (exports.MB_LOOKUP_FUNCTION = MB_LOOKUP_FUNCTION = {}));

let DATA_MAPPING_FUNCTION;
exports.DATA_MAPPING_FUNCTION = DATA_MAPPING_FUNCTION;

(function (DATA_MAPPING_FUNCTION) {
  DATA_MAPPING_FUNCTION["INTERPOLATE"] = "INTERPOLATE";
  DATA_MAPPING_FUNCTION["PERCENTILES"] = "PERCENTILES";
})(DATA_MAPPING_FUNCTION || (exports.DATA_MAPPING_FUNCTION = DATA_MAPPING_FUNCTION = {}));

const DEFAULT_PERCENTILES = [50, 75, 90, 95, 99];
exports.DEFAULT_PERCENTILES = DEFAULT_PERCENTILES;
const MAPS_NEW_VECTOR_LAYER_META_CREATED_BY = 'maps-new-vector-layer';
exports.MAPS_NEW_VECTOR_LAYER_META_CREATED_BY = MAPS_NEW_VECTOR_LAYER_META_CREATED_BY;
const MAX_DRAWING_SIZE_BYTES = 10485760; // 10MB

exports.MAX_DRAWING_SIZE_BYTES = MAX_DRAWING_SIZE_BYTES;
const NO_EMS_LOCALE = 'none';
exports.NO_EMS_LOCALE = NO_EMS_LOCALE;
const AUTOSELECT_EMS_LOCALE = 'autoselect';
exports.AUTOSELECT_EMS_LOCALE = AUTOSELECT_EMS_LOCALE;
const emsWorldLayerId = 'world_countries';
exports.emsWorldLayerId = emsWorldLayerId;
let WIZARD_ID;
exports.WIZARD_ID = WIZARD_ID;

(function (WIZARD_ID) {
  WIZARD_ID["CHOROPLETH"] = "choropleth";
  WIZARD_ID["GEO_FILE"] = "uploadGeoFile";
  WIZARD_ID["NEW_VECTOR"] = "newVectorLayer";
  WIZARD_ID["OBSERVABILITY"] = "observabilityLayer";
  WIZARD_ID["SECURITY"] = "securityLayer";
  WIZARD_ID["EMS_BOUNDARIES"] = "emsBoundaries";
  WIZARD_ID["EMS_BASEMAP"] = "emsBaseMap";
  WIZARD_ID["CLUSTERS"] = "clusters";
  WIZARD_ID["HEATMAP"] = "heatmap";
  WIZARD_ID["GEO_LINE"] = "geoLine";
  WIZARD_ID["POINT_2_POINT"] = "point2Point";
  WIZARD_ID["ES_DOCUMENT"] = "esDocument";
  WIZARD_ID["ES_TOP_HITS"] = "esTopHits";
  WIZARD_ID["KIBANA_BASEMAP"] = "kibanaBasemap";
  WIZARD_ID["MVT_VECTOR"] = "mvtVector";
  WIZARD_ID["WMS_LAYER"] = "wmsLayer";
  WIZARD_ID["TMS_LAYER"] = "tmsLayer";
})(WIZARD_ID || (exports.WIZARD_ID = WIZARD_ID = {}));