"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ALERT_THRESHOLD_RESULT_COUNT = exports.ALERT_THRESHOLD_RESULT = exports.ALERT_RULE_TIMESTAMP_OVERRIDE = exports.ALERT_RULE_TIMELINE_TITLE = exports.ALERT_RULE_TIMELINE_ID = exports.ALERT_RULE_THROTTLE = exports.ALERT_RULE_THREAT = exports.ALERT_RULE_SEVERITY_MAPPING = exports.ALERT_RULE_RISK_SCORE_MAPPING = exports.ALERT_RULE_META = exports.ALERT_RULE_MAX_SIGNALS = exports.ALERT_RULE_INDICES = exports.ALERT_RULE_IMMUTABLE = exports.ALERT_RULE_FALSE_POSITIVES = exports.ALERT_RULE_EXCEPTIONS_LIST = exports.ALERT_RULE_ACTIONS = exports.ALERT_ORIGINAL_TIME = exports.ALERT_ORIGINAL_EVENT_MODULE = exports.ALERT_ORIGINAL_EVENT_KIND = exports.ALERT_ORIGINAL_EVENT_CATEGORY = exports.ALERT_ORIGINAL_EVENT_ACTION = exports.ALERT_ORIGINAL_EVENT = exports.ALERT_NEW_TERMS = exports.ALERT_GROUP_INDEX = exports.ALERT_GROUP_ID = exports.ALERT_DEPTH = exports.ALERT_BUILDING_BLOCK_TYPE = exports.ALERT_ANCESTORS = void 0;

var _ruleDataUtils = require("@kbn/rule-data-utils");

/*
 * Copyright Elasticsearch B.V. and/or licensed to Elasticsearch B.V. under one
 * or more contributor license agreements. Licensed under the Elastic License
 * 2.0; you may not use this file except in compliance with the Elastic License
 * 2.0.
 */
const ALERT_ANCESTORS = `${_ruleDataUtils.ALERT_NAMESPACE}.ancestors`;
exports.ALERT_ANCESTORS = ALERT_ANCESTORS;
const ALERT_BUILDING_BLOCK_TYPE = `${_ruleDataUtils.ALERT_NAMESPACE}.building_block_type`;
exports.ALERT_BUILDING_BLOCK_TYPE = ALERT_BUILDING_BLOCK_TYPE;
const ALERT_DEPTH = `${_ruleDataUtils.ALERT_NAMESPACE}.depth`;
exports.ALERT_DEPTH = ALERT_DEPTH;
const ALERT_GROUP_ID = `${_ruleDataUtils.ALERT_NAMESPACE}.group.id`;
exports.ALERT_GROUP_ID = ALERT_GROUP_ID;
const ALERT_GROUP_INDEX = `${_ruleDataUtils.ALERT_NAMESPACE}.group.index`;
exports.ALERT_GROUP_INDEX = ALERT_GROUP_INDEX;
const ALERT_ORIGINAL_TIME = `${_ruleDataUtils.ALERT_NAMESPACE}.original_time`;
exports.ALERT_ORIGINAL_TIME = ALERT_ORIGINAL_TIME;
const ALERT_THRESHOLD_RESULT = `${_ruleDataUtils.ALERT_NAMESPACE}.threshold_result`;
exports.ALERT_THRESHOLD_RESULT = ALERT_THRESHOLD_RESULT;
const ALERT_THRESHOLD_RESULT_COUNT = `${ALERT_THRESHOLD_RESULT}.count`;
exports.ALERT_THRESHOLD_RESULT_COUNT = ALERT_THRESHOLD_RESULT_COUNT;
const ALERT_NEW_TERMS = `${_ruleDataUtils.ALERT_NAMESPACE}.new_terms`;
exports.ALERT_NEW_TERMS = ALERT_NEW_TERMS;
const ALERT_ORIGINAL_EVENT = `${_ruleDataUtils.ALERT_NAMESPACE}.original_event`;
exports.ALERT_ORIGINAL_EVENT = ALERT_ORIGINAL_EVENT;
const ALERT_ORIGINAL_EVENT_ACTION = `${ALERT_ORIGINAL_EVENT}.action`;
exports.ALERT_ORIGINAL_EVENT_ACTION = ALERT_ORIGINAL_EVENT_ACTION;
const ALERT_ORIGINAL_EVENT_CATEGORY = `${ALERT_ORIGINAL_EVENT}.category`;
exports.ALERT_ORIGINAL_EVENT_CATEGORY = ALERT_ORIGINAL_EVENT_CATEGORY;
const ALERT_ORIGINAL_EVENT_KIND = `${ALERT_ORIGINAL_EVENT}.kind`;
exports.ALERT_ORIGINAL_EVENT_KIND = ALERT_ORIGINAL_EVENT_KIND;
const ALERT_ORIGINAL_EVENT_MODULE = `${ALERT_ORIGINAL_EVENT}.module`;
exports.ALERT_ORIGINAL_EVENT_MODULE = ALERT_ORIGINAL_EVENT_MODULE;
const ALERT_RULE_ACTIONS = `${_ruleDataUtils.ALERT_RULE_NAMESPACE}.actions`;
exports.ALERT_RULE_ACTIONS = ALERT_RULE_ACTIONS;
const ALERT_RULE_EXCEPTIONS_LIST = `${_ruleDataUtils.ALERT_RULE_NAMESPACE}.exceptions_list`;
exports.ALERT_RULE_EXCEPTIONS_LIST = ALERT_RULE_EXCEPTIONS_LIST;
const ALERT_RULE_FALSE_POSITIVES = `${_ruleDataUtils.ALERT_RULE_NAMESPACE}.false_positives`;
exports.ALERT_RULE_FALSE_POSITIVES = ALERT_RULE_FALSE_POSITIVES;
const ALERT_RULE_IMMUTABLE = `${_ruleDataUtils.ALERT_RULE_NAMESPACE}.immutable`;
exports.ALERT_RULE_IMMUTABLE = ALERT_RULE_IMMUTABLE;
const ALERT_RULE_MAX_SIGNALS = `${_ruleDataUtils.ALERT_RULE_NAMESPACE}.max_signals`;
exports.ALERT_RULE_MAX_SIGNALS = ALERT_RULE_MAX_SIGNALS;
const ALERT_RULE_META = `${_ruleDataUtils.ALERT_RULE_NAMESPACE}.meta`;
exports.ALERT_RULE_META = ALERT_RULE_META;
const ALERT_RULE_RISK_SCORE_MAPPING = `${_ruleDataUtils.ALERT_RULE_NAMESPACE}.risk_score_mapping`;
exports.ALERT_RULE_RISK_SCORE_MAPPING = ALERT_RULE_RISK_SCORE_MAPPING;
const ALERT_RULE_SEVERITY_MAPPING = `${_ruleDataUtils.ALERT_RULE_NAMESPACE}.severity_mapping`;
exports.ALERT_RULE_SEVERITY_MAPPING = ALERT_RULE_SEVERITY_MAPPING;
const ALERT_RULE_THREAT = `${_ruleDataUtils.ALERT_RULE_NAMESPACE}.threat`;
exports.ALERT_RULE_THREAT = ALERT_RULE_THREAT;
const ALERT_RULE_THROTTLE = `${_ruleDataUtils.ALERT_RULE_NAMESPACE}.throttle`;
exports.ALERT_RULE_THROTTLE = ALERT_RULE_THROTTLE;
const ALERT_RULE_TIMELINE_ID = `${_ruleDataUtils.ALERT_RULE_NAMESPACE}.timeline_id`;
exports.ALERT_RULE_TIMELINE_ID = ALERT_RULE_TIMELINE_ID;
const ALERT_RULE_TIMELINE_TITLE = `${_ruleDataUtils.ALERT_RULE_NAMESPACE}.timeline_title`;
exports.ALERT_RULE_TIMELINE_TITLE = ALERT_RULE_TIMELINE_TITLE;
const ALERT_RULE_TIMESTAMP_OVERRIDE = `${_ruleDataUtils.ALERT_RULE_NAMESPACE}.timestamp_override`;
exports.ALERT_RULE_TIMESTAMP_OVERRIDE = ALERT_RULE_TIMESTAMP_OVERRIDE;
const ALERT_RULE_INDICES = `${_ruleDataUtils.ALERT_RULE_NAMESPACE}.indices`;
exports.ALERT_RULE_INDICES = ALERT_RULE_INDICES;